// Datei: interupt.c
// PIC Interrupts
//
// hk@holger-klabunde.de
// www.holger-klabunde.de
// 05.05.2002
// Compiler CC5X

#include <int16CXX.H>

#pragma origin 4  //Interruptvektor vom PIC

unsigned char shapecount;
unsigned char offset;
unsigned char sbuf,tmp;

interrupt int_server( void)
{
//Alle wichtigen Register retten
 int_save_registers    // W, STATUS (and PCLATH)

//******************************
//PWM Timerinterrupt
//******************************
 if(TMR2IF) 
  {
   sbuf=shapecount;

   tmp=sbuf>>2;
   sbuf&=0x03;          //Bit0,1 isolieren
   sbuf<<=4;
   CCP1CON&=~0x30;      //alte Bits lschen
   CCP1CON|=sbuf;       //die unteren beiden Bits in CCP1CON schieben
   CCPR1L=tmp;          //nur die sechs oberen Bits sind hier
   TMR2IF=0;            //Interruptflag lschen sonst
                        //Endlosinterrupt
   shapecount++;
   if(shapecount==0) shapecount=offset; //neuen Startpunkt setzen
  }
//Ende PWM Interrupt

//Alle wichtigen Register wiederherstellen
 int_restore_registers // W, STATUS (and PCLATH)
}
